/* upgrade-dialog.c generated by valac 0.50.1, the Vala compiler
 * generated from upgrade-dialog.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-3.38.h"
#include "geary-engine.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

enum  {
	UPGRADE_DIALOG_0_PROPERTY,
	UPGRADE_DIALOG_MONITOR_PROPERTY,
	UPGRADE_DIALOG_VISIBLE_PROPERTY,
	UPGRADE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* upgrade_dialog_properties[UPGRADE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UpgradeDialogPrivate {
	GearyAggregateProgressMonitor* _monitor;
	gboolean _visible;
	ApplicationClient* application;
	GtkDialog* dialog;
	GeeHashSet* cancellables;
};

static gint UpgradeDialog_private_offset;
static gpointer upgrade_dialog_parent_class = NULL;

static void upgrade_dialog_set_monitor (UpgradeDialog* self,
                                 GearyAggregateProgressMonitor* value);
static void upgrade_dialog_on_start (UpgradeDialog* self);
static void _upgrade_dialog_on_start_geary_progress_monitor_start (GearyProgressMonitor* _sender,
                                                            gpointer self);
static void upgrade_dialog_on_close (UpgradeDialog* self);
static void _upgrade_dialog_on_close_geary_progress_monitor_finish (GearyProgressMonitor* _sender,
                                                             gpointer self);
static gboolean upgrade_dialog_on_delete_event (UpgradeDialog* self);
static gboolean _upgrade_dialog_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                  GdkEventAny* event,
                                                                  gpointer self);
static void upgrade_dialog_finalize (GObject * obj);
static GType upgrade_dialog_get_type_once (void);
static void _vala_upgrade_dialog_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_upgrade_dialog_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
upgrade_dialog_get_instance_private (UpgradeDialog* self)
{
	return G_STRUCT_MEMBER_P (self, UpgradeDialog_private_offset);
}

GearyAggregateProgressMonitor*
upgrade_dialog_get_monitor (UpgradeDialog* self)
{
	GearyAggregateProgressMonitor* result;
	GearyAggregateProgressMonitor* _tmp0_;
	g_return_val_if_fail (IS_UPGRADE_DIALOG (self), NULL);
	_tmp0_ = self->priv->_monitor;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
upgrade_dialog_set_monitor (UpgradeDialog* self,
                            GearyAggregateProgressMonitor* value)
{
	g_return_if_fail (IS_UPGRADE_DIALOG (self));
	if (upgrade_dialog_get_monitor (self) != value) {
		GearyAggregateProgressMonitor* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_monitor);
		self->priv->_monitor = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, upgrade_dialog_properties[UPGRADE_DIALOG_MONITOR_PROPERTY]);
	}
}

gboolean
upgrade_dialog_get_visible (UpgradeDialog* self)
{
	gboolean result;
	g_return_val_if_fail (IS_UPGRADE_DIALOG (self), FALSE);
	result = self->priv->_visible;
	return result;
}

void
upgrade_dialog_set_visible (UpgradeDialog* self,
                            gboolean value)
{
	g_return_if_fail (IS_UPGRADE_DIALOG (self));
	if (upgrade_dialog_get_visible (self) != value) {
		self->priv->_visible = value;
		g_object_notify_by_pspec ((GObject *) self, upgrade_dialog_properties[UPGRADE_DIALOG_VISIBLE_PROPERTY]);
	}
}

/**
     * Creates and loads the upgrade progress dialog.
     */
static void
_upgrade_dialog_on_start_geary_progress_monitor_start (GearyProgressMonitor* _sender,
                                                       gpointer self)
{
	upgrade_dialog_on_start ((UpgradeDialog*) self);
}

static void
_upgrade_dialog_on_close_geary_progress_monitor_finish (GearyProgressMonitor* _sender,
                                                        gpointer self)
{
	upgrade_dialog_on_close ((UpgradeDialog*) self);
}

UpgradeDialog*
upgrade_dialog_construct (GType object_type,
                          ApplicationClient* application)
{
	UpgradeDialog * self = NULL;
	GearyAggregateProgressMonitor* _tmp0_;
	GearyAggregateProgressMonitor* _tmp1_;
	g_return_val_if_fail (APPLICATION_IS_CLIENT (application), NULL);
	self = (UpgradeDialog*) g_object_new (object_type, NULL);
	self->priv->application = application;
	_tmp0_ = self->priv->_monitor;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor), "start", (GCallback) _upgrade_dialog_on_start_geary_progress_monitor_start, self, 0);
	_tmp1_ = self->priv->_monitor;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor), "finish", (GCallback) _upgrade_dialog_on_close_geary_progress_monitor_finish, self, 0);
	return self;
}

UpgradeDialog*
upgrade_dialog_new (ApplicationClient* application)
{
	return upgrade_dialog_construct (TYPE_UPGRADE_DIALOG, application);
}

static gboolean
_upgrade_dialog_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                         GdkEventAny* event,
                                                         gpointer self)
{
	gboolean result;
	result = upgrade_dialog_on_delete_event ((UpgradeDialog*) self);
	return result;
}

static void
upgrade_dialog_on_start (UpgradeDialog* self)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp9_;
	GObject* _tmp10_;
	GtkDialog* _tmp11_;
	GtkDialog* _tmp12_;
	ApplicationClient* _tmp13_;
	ApplicationMainWindow* _tmp14_;
	ApplicationMainWindow* _tmp15_;
	GtkDialog* _tmp16_;
	GtkDialog* _tmp17_;
	g_return_if_fail (IS_UPGRADE_DIALOG (self));
	{
		GeeIterator* _window_it = NULL;
		ApplicationClient* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = self->priv->application;
		_tmp1_ = application_client_get_main_windows (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_window_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			ApplicationMainWindow* window = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			ApplicationMainWindow* _tmp8_;
			_tmp5_ = _window_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _window_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			window = (ApplicationMainWindow*) _tmp7_;
			_tmp8_ = window;
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), FALSE);
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_it);
	}
	_tmp9_ = gio_util_create_builder ("upgrade_dialog.glade");
	builder = _tmp9_;
	_tmp10_ = gtk_builder_get_object (builder, "dialog");
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_dialog_get_type (), GtkDialog));
	_g_object_unref0 (self->priv->dialog);
	self->priv->dialog = _tmp11_;
	_tmp12_ = self->priv->dialog;
	_tmp13_ = self->priv->application;
	_tmp14_ = application_client_get_active_main_window (_tmp13_);
	_tmp15_ = _tmp14_;
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_window_get_type (), GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_window_get_type (), GtkWindow));
	_g_object_unref0 (_tmp15_);
	_tmp16_ = self->priv->dialog;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), "delete-event", (GCallback) _upgrade_dialog_on_delete_event_gtk_widget_delete_event, self, 0);
	_tmp17_ = self->priv->dialog;
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
	_g_object_unref0 (builder);
}

static gboolean
upgrade_dialog_on_delete_event (UpgradeDialog* self)
{
	GearyAggregateProgressMonitor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (IS_UPGRADE_DIALOG (self), FALSE);
	_tmp0_ = self->priv->_monitor;
	_tmp1_ = geary_progress_monitor_get_is_in_progress (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor));
	_tmp2_ = _tmp1_;
	result = !_tmp2_;
	return result;
}

static void
upgrade_dialog_on_close (UpgradeDialog* self)
{
	GearyAggregateProgressMonitor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp9_ = FALSE;
	GtkDialog* _tmp10_;
	g_return_if_fail (IS_UPGRADE_DIALOG (self));
	_tmp0_ = self->priv->_monitor;
	_tmp1_ = geary_progress_monitor_get_is_in_progress (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor));
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		{
			GeeIterator* _c_it = NULL;
			GeeHashSet* _tmp3_;
			GeeIterator* _tmp4_;
			_tmp3_ = self->priv->cancellables;
			_tmp4_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
			_c_it = _tmp4_;
			while (TRUE) {
				GeeIterator* _tmp5_;
				GCancellable* c = NULL;
				GeeIterator* _tmp6_;
				gpointer _tmp7_;
				GCancellable* _tmp8_;
				_tmp5_ = _c_it;
				if (!gee_iterator_next (_tmp5_)) {
					break;
				}
				_tmp6_ = _c_it;
				_tmp7_ = gee_iterator_get (_tmp6_);
				c = (GCancellable*) _tmp7_;
				_tmp8_ = c;
				g_cancellable_cancel (_tmp8_);
				_g_object_unref0 (c);
			}
			_g_object_unref0 (_c_it);
		}
	}
	_tmp10_ = self->priv->dialog;
	if (_tmp10_ != NULL) {
		GtkDialog* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp11_ = self->priv->dialog;
		_tmp12_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
		_tmp13_ = _tmp12_;
		_tmp9_ = _tmp13_;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GtkDialog* _tmp14_;
		_tmp14_ = self->priv->dialog;
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
		_g_object_unref0 (self->priv->dialog);
		self->priv->dialog = NULL;
	}
	{
		GeeIterator* _window_it = NULL;
		ApplicationClient* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeIterator* _tmp18_;
		GeeIterator* _tmp19_;
		_tmp15_ = self->priv->application;
		_tmp16_ = application_client_get_main_windows (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ITERABLE, GeeIterable));
		_tmp19_ = _tmp18_;
		_g_object_unref0 (_tmp17_);
		_window_it = _tmp19_;
		while (TRUE) {
			GeeIterator* _tmp20_;
			ApplicationMainWindow* window = NULL;
			GeeIterator* _tmp21_;
			gpointer _tmp22_;
			ApplicationMainWindow* _tmp23_;
			_tmp20_ = _window_it;
			if (!gee_iterator_next (_tmp20_)) {
				break;
			}
			_tmp21_ = _window_it;
			_tmp22_ = gee_iterator_get (_tmp21_);
			window = (ApplicationMainWindow*) _tmp22_;
			_tmp23_ = window;
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), TRUE);
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_it);
	}
}

/**
     * Adds an account to be monitored for upgrades by the dialog.
     *
     * Accounts should be added before being opened.
     */
void
upgrade_dialog_add_account (UpgradeDialog* self,
                            GearyAccount* account,
                            GCancellable* cancellable)
{
	GearyAggregateProgressMonitor* _tmp0_;
	GearyProgressMonitor* _tmp1_;
	GearyProgressMonitor* _tmp2_;
	GearyAggregateProgressMonitor* _tmp3_;
	GearyProgressMonitor* _tmp4_;
	GearyProgressMonitor* _tmp5_;
	g_return_if_fail (IS_UPGRADE_DIALOG (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
	_tmp0_ = self->priv->_monitor;
	_tmp1_ = geary_account_get_db_upgrade_monitor (account);
	_tmp2_ = _tmp1_;
	geary_aggregate_progress_monitor_add (_tmp0_, _tmp2_);
	_tmp3_ = self->priv->_monitor;
	_tmp4_ = geary_account_get_db_vacuum_monitor (account);
	_tmp5_ = _tmp4_;
	geary_aggregate_progress_monitor_add (_tmp3_, _tmp5_);
	if (cancellable != NULL) {
		GeeHashSet* _tmp6_;
		_tmp6_ = self->priv->cancellables;
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), cancellable);
	}
}

/**
     * Stops an account from being monitored.
     */
void
upgrade_dialog_remove_account (UpgradeDialog* self,
                               GearyAccount* account)
{
	GearyAggregateProgressMonitor* _tmp0_;
	GearyProgressMonitor* _tmp1_;
	GearyProgressMonitor* _tmp2_;
	GearyAggregateProgressMonitor* _tmp3_;
	GearyProgressMonitor* _tmp4_;
	GearyProgressMonitor* _tmp5_;
	g_return_if_fail (IS_UPGRADE_DIALOG (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
	_tmp0_ = self->priv->_monitor;
	_tmp1_ = geary_account_get_db_upgrade_monitor (account);
	_tmp2_ = _tmp1_;
	geary_aggregate_progress_monitor_remove (_tmp0_, _tmp2_);
	_tmp3_ = self->priv->_monitor;
	_tmp4_ = geary_account_get_db_vacuum_monitor (account);
	_tmp5_ = _tmp4_;
	geary_aggregate_progress_monitor_remove (_tmp3_, _tmp5_);
}

static void
upgrade_dialog_class_init (UpgradeDialogClass * klass,
                           gpointer klass_data)
{
	upgrade_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UpgradeDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_upgrade_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_upgrade_dialog_set_property;
	G_OBJECT_CLASS (klass)->finalize = upgrade_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), UPGRADE_DIALOG_MONITOR_PROPERTY, upgrade_dialog_properties[UPGRADE_DIALOG_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", GEARY_TYPE_AGGREGATE_PROGRESS_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), UPGRADE_DIALOG_VISIBLE_PROPERTY, upgrade_dialog_properties[UPGRADE_DIALOG_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
upgrade_dialog_instance_init (UpgradeDialog * self,
                              gpointer klass)
{
	GearyAggregateProgressMonitor* _tmp0_;
	GeeHashSet* _tmp1_;
	self->priv = upgrade_dialog_get_instance_private (self);
	_tmp0_ = geary_aggregate_progress_monitor_new ();
	self->priv->_monitor = _tmp0_;
	self->priv->dialog = NULL;
	_tmp1_ = gee_hash_set_new (g_cancellable_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->cancellables = _tmp1_;
}

static void
upgrade_dialog_finalize (GObject * obj)
{
	UpgradeDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UPGRADE_DIALOG, UpgradeDialog);
	_g_object_unref0 (self->priv->_monitor);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->priv->cancellables);
	G_OBJECT_CLASS (upgrade_dialog_parent_class)->finalize (obj);
}

static GType
upgrade_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UpgradeDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upgrade_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UpgradeDialog), 0, (GInstanceInitFunc) upgrade_dialog_instance_init, NULL };
	GType upgrade_dialog_type_id;
	upgrade_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "UpgradeDialog", &g_define_type_info, 0);
	UpgradeDialog_private_offset = g_type_add_instance_private (upgrade_dialog_type_id, sizeof (UpgradeDialogPrivate));
	return upgrade_dialog_type_id;
}

GType
upgrade_dialog_get_type (void)
{
	static volatile gsize upgrade_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&upgrade_dialog_type_id__volatile)) {
		GType upgrade_dialog_type_id;
		upgrade_dialog_type_id = upgrade_dialog_get_type_once ();
		g_once_init_leave (&upgrade_dialog_type_id__volatile, upgrade_dialog_type_id);
	}
	return upgrade_dialog_type_id__volatile;
}

static void
_vala_upgrade_dialog_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	UpgradeDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UPGRADE_DIALOG, UpgradeDialog);
	switch (property_id) {
		case UPGRADE_DIALOG_MONITOR_PROPERTY:
		g_value_set_object (value, upgrade_dialog_get_monitor (self));
		break;
		case UPGRADE_DIALOG_VISIBLE_PROPERTY:
		g_value_set_boolean (value, upgrade_dialog_get_visible (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_upgrade_dialog_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	UpgradeDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UPGRADE_DIALOG, UpgradeDialog);
	switch (property_id) {
		case UPGRADE_DIALOG_MONITOR_PROPERTY:
		upgrade_dialog_set_monitor (self, g_value_get_object (value));
		break;
		case UPGRADE_DIALOG_VISIBLE_PROPERTY:
		upgrade_dialog_set_visible (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

